diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/Manifest.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/Manifest.java
index 8ceba85e6..24c7a0596 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/Manifest.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/Manifest.java
@@ -2,12 +2,15 @@ package net.minecraft.client.render.texturepack;
 
 import java.io.File;
 import java.io.InputStream;
+import java.util.HashSet;
+import java.util.Set;
 
 import com.b100.json.JsonParser;
 import com.b100.json.element.JsonElement;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.InvalidCharacterException;
 import com.b100.utils.StringUtils;
+import org.jetbrains.annotations.NotNull;
 
 public class Manifest
     extends ManifestBase {
@@ -16,6 +19,8 @@ public class Manifest
     private final String line2;
     private final String packVersion;
     private final int format;
+	private final int minSupported;
+	private final int maxSupported;
 
     public Manifest(File texturePackFile, InputStream stream) {
     	String string = StringUtils.readInputString(stream);
@@ -48,7 +53,9 @@ public class Manifest
     	JsonElement line2 = description.get("line2");
     	JsonElement packVersion = description.get("packVersion");
     	JsonElement format = description.get("format");
-    	
+    	JsonElement minFormat = description.get("min_format");
+    	JsonElement maxFormat = description.get("max_format");
+
     	if(name != null && name.isString()) {
     		this.name = name.getAsString().value;
     	}else {
@@ -86,6 +93,26 @@ public class Manifest
     	}else {
     		throw new ManifestException("Missing \"format\" Integer!");
     	}
+
+		if(minFormat != null) {
+			if(minFormat.isNumber()) {
+				this.minSupported = minFormat.getAsNumber().getInteger();
+			}else {
+				throw new ManifestException("\"min_format\" must be an Integer!");
+			}
+		}else {
+			this.minSupported = this.format;
+		}
+
+		if(maxFormat != null) {
+			if(maxFormat.isNumber()) {
+				this.maxSupported = maxFormat.getAsNumber().getInteger();
+			}else {
+				throw new ManifestException("\"max_format\" must be an Integer!");
+			}
+		}else {
+			this.maxSupported = this.minSupported;
+		}
     }
 
     @Override
@@ -112,8 +139,19 @@ public class Manifest
     public int getFormat() {
         return format;
     }
-    
-    /**
+
+	@Override
+	public int getMinFormat() {
+		return this.minSupported;
+	}
+
+	@Override
+	public int getMaxFormat() {
+		return this.maxSupported;
+	}
+
+
+	/**
      * A readable error to be displayed 
      */
     @SuppressWarnings("serial")
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestBase.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestBase.java
index 7197e7b1c..a8dd13a9b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestBase.java
@@ -10,4 +10,7 @@ public abstract class ManifestBase {
     public abstract String getPackVersion();
 
     public abstract int getFormat();
+
+    public abstract int getMinFormat();
+    public abstract int getMaxFormat();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestFallback.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestFallback.java
index 60cdf3c62..e476c5ccc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestFallback.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/ManifestFallback.java
@@ -38,4 +38,14 @@ public class ManifestFallback
     public int getFormat() {
         return format;
     }
+
+    @Override
+    public int getMinFormat() {
+        return format;
+    }
+
+    @Override
+    public int getMaxFormat() {
+        return format;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 6849c8bcc..8ac8fc20e 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -61,6 +61,7 @@ public class WorldClientMP extends WorldClient {
         if (getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
             this.getLevelData().setWorldTime(this.getLevelData().getWorldTime() + 1L);
         }
+        this.getLevelData().setTotalWorldTime(this.getLevelData().getTotalWorldTime() + 1L);
         for (int k = 0; k < 10 && !this.reEntries.isEmpty(); k++) {
             Entity entity = this.reEntries.iterator().next();
             if (!this.entities.contains(entity)) {
diff --git a/game/client/src/main/resources/assets/minecraft/textures/item/ammo_arrow_flaming.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/item/ammo_arrow_flaming.png.mcmeta
new file mode 100644
index 000000000..7e77c6485
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/item/ammo_arrow_flaming.png.mcmeta
@@ -0,0 +1,5 @@
+{
+  "animation": {
+    "frametime": 2
+  }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
index fbddff06b..38dbe4612 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -6,6 +6,8 @@ import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class Achievement extends Stat
 {
@@ -13,36 +15,34 @@ public class Achievement extends Stat
     public static final Type TYPE_SPECIAL = new Type("minecraft:gui/screen/achievement/achievement_special", 0xffffff80, 0xff808040, false);
     public static final Type TYPE_SECRET = new Type("minecraft:gui/screen/achievement/achievement_secret", 0xff8080ff, 0xff404080, true);
 
-    public final Achievement parent;
-    private final String description;
-    private StatDescFormatter statStringFormatter;
-    public final int iconItemId;
-    private Type type = TYPE_NORMAL;
-    public final ItemStack iconStack;
+    public final @Nullable Achievement parent;
+    private final @NotNull String description;
+    private @Nullable StatDescFormatter statStringFormatter;
+    private @NotNull Type type = TYPE_NORMAL;
+    public final @NotNull ItemStack iconStack;
 
-    public Achievement(NamespaceID id, String name, ItemStack icon, Achievement parent) {
-        super(NamespaceID.fromPool(id.namespace(), "achievement/" + id.value()), "achievement." + name);
+    public Achievement(@NotNull NamespaceID id, @NotNull String name, @NotNull ItemStack icon, @Nullable Achievement parent) {
+        super(new NamespaceID(id.namespace(), "achievement/" + id.value()), "achievement." + name);
         this.iconStack = icon;
-        this.iconItemId = icon.itemID;
         this.description = "achievement." + name;
         this.parent = parent;
     }
 
-    public Achievement(NamespaceID id, String name, IItemConvertible icon, Achievement parent) {
-        this(id, name, new ItemStack(icon), parent);
+    public Achievement(@NotNull NamespaceID id, @NotNull String name, @NotNull IItemConvertible icon, @Nullable Achievement parent) {
+        this(id, name, icon.getDefaultStack(), parent);
     }
 
-    public Achievement setClientsideAchievement() {
-        clientside = true;
+    public @NotNull Achievement setClientsideAchievement() {
+        this.clientside = true;
         return this;
     }
 
-    public Achievement setType(Type type) {
+    public @NotNull Achievement setType(Type type) {
         this.type = type;
         return this;
     }
 
-    public Achievement registerAchievement() {
+    public @NotNull Achievement registerAchievement() {
         super.registerStat();
         Achievements.achievementList.add(this);
         return this;
@@ -54,48 +54,31 @@ public class Achievement extends Stat
         return true;
     }
 
-    public String getDescription()
-    {
-        if(statStringFormatter != null)
-        {
-            return statStringFormatter.formatString(I18n.getInstance().translateKey(description + ".desc"));
-        } else
-        {
-            return I18n.getInstance().translateKey(description + ".desc");
-        }
+    public @NotNull String getDescription() {
+        if (this.statStringFormatter == null) return I18n.getInstance().translateKey(this.description + ".desc");
+        return this.statStringFormatter.formatString(I18n.getInstance().translateKey(this.description + ".desc"));
     }
 
-    public Achievement setDescriptionFormatter(StatDescFormatter descFormatter) {
-        statStringFormatter = descFormatter;
+    public @NotNull Achievement setDescriptionFormatter(@Nullable StatDescFormatter descFormatter) {
+        this.statStringFormatter = descFormatter;
         return this;
     }
 
-    public Type getType() {
-        return type;
+    public @NotNull Type getType() {
+        return this.type;
     }
 
     @Override
-	public Stat registerStat()
+	public @NotNull Stat registerStat()
     {
         return registerAchievement();
     }
 
     @Override
-	public Stat setClientside()
+	public @NotNull Stat setClientside()
     {
         return setClientsideAchievement();
     }
 
-    public static class Type {
-        public final String texture;
-        public final int colorName;
-        public final int colorNameLocked;
-        public final boolean hidden;
-        public Type(String texture, int colorName, int colorNameLocked, boolean hidden){
-            this.texture = texture;
-            this.colorName = colorName;
-            this.colorNameLocked = colorNameLocked;
-            this.hidden = hidden;
-        }
-    }
+    public record Type(String texture, int colorName, int colorNameLocked, boolean hidden) { }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index 9e05ec69e..83e08154c 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -130,7 +130,7 @@ public abstract class Achievements
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement SWIM_NETHER =
-        new Achievement(NamespaceID.fromPool("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "swim_nether"), "swimNether", ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_WATER, 1), ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement HIT_FIREBALL =
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
index b90489c0d..28e94b776 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
@@ -2,6 +2,7 @@ package net.minecraft.core.achievement.stat;
 
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 
 import java.text.DecimalFormat;
 import java.text.NumberFormat;
@@ -44,13 +45,13 @@ public class Stat
         return statKey;
     }
 
-    public Stat setClientside()
+    public @NotNull Stat setClientside()
     {
         clientside = true;
         return this;
     }
 
-    public Stat registerStat()
+    public @NotNull Stat registerStat()
     {
         if (StatList.statMap.containsKey(statId))
         {
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
index bdf809cfa..3e1593fbb 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.achievement.stat;
 
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 
 public class StatBasic extends Stat
 {
@@ -16,7 +17,7 @@ public class StatBasic extends Stat
     }
 
     @Override
-	public Stat registerStat()
+	public @NotNull Stat registerStat()
     {
         super.registerStat();
         StatList.basicStats.add(this);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
index 72252d6e2..a2b9673f5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -45,6 +45,12 @@ public class BlockLogicButtonPainted
         return meta & ~MASK_COLOR;
     }
 
+    @Override
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
+        final int meta = world.getBlockData(tilePos);
+        world.setBlockDataNotify(tilePos, meta | color.blockMeta << 4);
+    }
+
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         world.setBlockTypeNotify(tilePos, Blocks.BUTTON_PLANKS_OAK);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 3e0fc96f6..15bdca4af 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -48,7 +48,6 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
         }
     }
 
-
     public boolean canMossSpread(@NotNull World world, @NotNull TilePosc tilePos) {
         if (!world.isBlockLoaded(tilePos)) return false;
         int maxBlockLight = 0;
@@ -101,34 +100,30 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 
     @Override
     public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        if (!world.isClientSide) {
-            if (!canMossSpread(world, tilePos) || !airExposed(world, tilePos)) return false;
-            if (player == null || player.getGamemode().hasBlockConsumption()) {
-                itemStack.stackSize--;
-            }
-            for (int i = 0; i < 32; i++) {
-                TilePos randomPos = new TilePos(tilePos);
-                for (int j = 0; j < i / 16; j++) {
-                    randomPos.x += world.rand.nextInt(3) - 1;
-                    randomPos.y += ((world.rand.nextInt(3) - 1) * world.rand.nextInt(3)) / 2;
-                    randomPos.z += world.rand.nextInt(3) - 1;
-                }
+        if (world.isClientSide) return false;
 
-                if (!airExposed(world, randomPos)) {
-                    continue;
-                }
+        if (itemStack.stackSize <= 0) return false;
+        if (!this.airExposed(world, tilePos)) return false;
 
-                if (!canMossSpread(world, randomPos)) {
-                    continue;
-                }
+        final var query = new TilePos();
 
-                @Nullable Block<?> block = getMossBlock(world.getBlockType(randomPos));
-                if (block != null) {
-                    world.setBlockTypeNotify(randomPos, block);
-                }
-            }
+        final var dirs = new Direction[Direction.count];
+        System.arraycopy(Direction.all, 0, dirs, 0, Direction.count);
+    
+        for (int i = 0; i < Direction.count; i++) {
+            final int j = world.rand.nextInt(Direction.count - i) + i;
+            final var testPos = tilePos.add(dirs[j], query);
+            dirs[j] = dirs[i];
+
+            if (!this.canMossSpread(world, testPos)) continue;
+            @Nullable Block<?> mossStone = getMossBlock(world.getBlockType(testPos));
+            if (mossStone == null) continue;
+
+            if (!world.setBlockTypeNotify(testPos, mossStone)) continue;
+            itemStack.consumeItem(player);
+            return true;
         }
-        return true;
+        return false;
     }
 
     public boolean airExposed(@NotNull World world, @NotNull TilePosc tilePos) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 2a1c03195..86705f3c0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -15,6 +15,7 @@ import java.util.Random;
 
 public class BlockLogicSponge extends BlockLogic {
     final boolean isWet;
+    boolean skipDrying = false;
 
     public BlockLogicSponge(@NotNull Block<?> block, boolean isWet) {
         super(block, Materials.SPONGE);
@@ -24,8 +25,11 @@ public class BlockLogicSponge extends BlockLogic {
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
+        if (this.skipDrying) return;
         if ((world.getWorldType().hasTag(WorldTypeTags.HOT) || inHot(world, tilePos)) && this.isWet) {
+            this.skipDrying = true;
             world.setBlockTypeNotify(tilePos, Blocks.SPONGE_DRY);
+            this.skipDrying = false;
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for (int l = 0; l < 8; l++) {
                 world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0, false);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index 374e034f4..bc066db77 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -232,7 +232,7 @@ public class TileEntityActivator extends TileEntity implements Container, ICarry
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 424111057..cd3774ccb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -22,6 +22,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
@@ -236,7 +237,7 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 4b05280a8..876ec1cca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -156,7 +156,7 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index 91bdcd264..4cfc1c4f7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -219,7 +219,7 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index d000affae..23006d561 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -396,7 +396,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 87b75ad4a..e2bb6252c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -354,7 +354,7 @@ public class TileEntityFurnaceBlast extends TileEntity
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 691d2cbe5..d29136e9a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -574,7 +574,7 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+    public @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         return super.pickup(world, holder, tilePos_);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index e4f2f14cd..761f2b269 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -262,6 +262,7 @@ public class EntityFallingBlock extends Entity
             this.carriedBlock.entity.writeToNBT(entityTag);
             tag.putCompound("TileEntity", entityTag);
         }
+        tag.putBoolean("hasRemovedBlock", this.hasRemovedBlock);
     }
 
     @Override
@@ -274,6 +275,7 @@ public class EntityFallingBlock extends Entity
         if (this.carriedBlock.entity != null) {
             this.carriedBlock.entity.carriedBlock = this.carriedBlock;
         }
+        this.hasRemovedBlock = tag.getBooleanOrDefault("hasRemovedBlock", true);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 3e6016425..e0a0e7dc9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1816,6 +1816,8 @@ public abstract class Player
             nextArrow = Items.AMMO_ARROW;
         } else if (quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER_GOLD.id) {
             nextArrow = Items.AMMO_ARROW_PURPLE;
+        } else if (hasItem(Items.AMMO_ARROW_FLAMING)) {
+            nextArrow = Items.AMMO_ARROW_FLAMING;
         } else if (hasItem(Items.AMMO_ARROW_GOLD)) {
             nextArrow = Items.AMMO_ARROW_GOLD;
         } else if (hasItem(Items.AMMO_ARROW)) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
index 4f28e67cc..0f51b4e85 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
@@ -2,6 +2,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.entity.projectile.ProjectileArrowFlaming;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.entity.player.Player;
@@ -34,6 +35,13 @@ public class ItemBow extends Item {
             if (!world.isClientSide) {
                 world.entityJoinedWorld(new ProjectileArrowPurple(world, player, false));
             }
+        } else if (player.inventory.consumeInventoryItem(Items.AMMO_ARROW_FLAMING.id)) {
+            selfStack.damageItem(1, player);
+            world.playSoundAtEntity(player, player, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
+            if(!world.isClientSide)
+            {
+                world.entityJoinedWorld(new ProjectileArrowFlaming(world, player, true));
+            }
         } else if (player.inventory.consumeInventoryItem(Items.AMMO_ARROW_GOLD.id))
         {
             selfStack.damageItem(1, player);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index 86da7cdc2..2629cb1b5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -85,6 +85,8 @@ public class ItemJar extends ItemPlaceable {
         final int count = pokemon.onCaptured();
         if (count == 0) return null;
 
+        if (!selfStack.consumeItem(player)) return null;
+
         final Item resultingItem;
         if (pokemon instanceof MobFireflyCluster firefly) resultingItem = captureFirefly(firefly);
         else if (pokemon instanceof MobButterfly butterfly) resultingItem = captureButterfly(butterfly);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
index 2b7fabb42..3e57f99a4 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
@@ -37,6 +37,7 @@ public class SlotResult extends Slot
 		
 		if(item.id == Blocks.WORKBENCH.id()) thePlayer.addStat(Achievements.BUILD_WORKBENCH, 1);
 		if(item.id == Blocks.FURNACE_STONE_IDLE.id()) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
+		if(item.id == Blocks.FURNACE_BLAST_IDLE.id()) thePlayer.addStat(Achievements.GET_STEEL_BLAST_FURNACE, 1);
 		if(item.id == Items.FOOD_BREAD.id) thePlayer.addStat(Achievements.MAKE_BREAD, 1);
 		if(item.id == Items.FOOD_CAKE.id) thePlayer.addStat(Achievements.BAKE_CAKE, 1);
 		if(item instanceof ItemBucket && ItemBucket.getState(itemStack) == ItemBucket.STATE_ICECREAM) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java b/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java
index 4a12e9ec3..34e14520f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java
@@ -7,7 +7,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.pos.TilePosc;
 
 public interface ICarrySource {
-    @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos);
+    @Nullable ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos);
 
     public static @Nullable ICarrySource getFromWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         if (world.getTileEntity(tilePos) instanceof ICarrySource carryTE) return carryTE;
@@ -15,11 +15,12 @@ public interface ICarrySource {
         return null;
     }
 
-    public static @Nullable ICarrySource tryPickUpFromWorld(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos) {
+    public static @Nullable ICarriable tryPickUpFromWorld(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos) {
         final @Nullable var carry = getFromWorld(world, tilePos);
-        if (carry != null) {
-            holder.setHeldObject(carry.pickup(world, holder, tilePos));
-        }
-        return carry;
+        if (carry == null) return null;
+        final var carried = carry.pickup(world, holder, tilePos);
+        if (carried == null) return null;
+        holder.setHeldObject(carried);
+        return carried;
     }
 }
